class FileDiffMap

  class Entry < Struct.new(:name, :size, :status);end

  attr_reader :diff_map
  def initialize
    @diff_map = {}
  end


  def add(name, size)
    raise "file #{name} already exists!" if(diff_map[name])
    diff_map[name] = Entry.new(name, size, :local)

    :local
  end


  def update(name, size)
    if(diff_map[name])

      if diff_map[name].size == size
        diff_map[name].status = :match

      else
        diff_map[name].status = :diff
      end
     
    else
      
      diff_map[name] = Entry.new(name, size, :remote)
      :remote
    end

  end


  def entries
    diff_map.values 
  end

  def local_entries
    diff_map.values.find_all {|e| e.status == :local}
  end


end