require "sftp/sync/glob_builder"

# maybe move int git_ignore/filter

module Filters
  class GitIgnore

    attr_reader :globs, :negative_globs

    def initialize(patterns = [])


      @globs = [] 
      @negative_globs = []

      patterns.each do |pattern|

        pattern.strip!

        next if /^\#/.match(pattern)
   
        if /^\\\#/.match(pattern)
          add_globs Sftp::Sync::GlobBuilder.new(pattern.slice(1,pattern.length - 1))
        else
           add_globs Sftp::Sync::GlobBuilder.new(pattern)
        end

      end

    end


    def match(filename)


      @globs.each do |glob|
        if File.fnmatch(glob, filename,  File::FNM_PATHNAME) #  removeing path thing? (or be mor specific w/ glob)


          @negative_globs.each do |n_glob|
            return false if File.fnmatch(n_glob, filename,  File::FNM_PATHNAME)
          end

          return true 

        end
      end
      false
    end

    private

    def add_globs(builder)

      if builder.negative?
        @negative_globs = (@negative_globs + builder.globs).uniq
      else
        @globs = (@globs + builder.globs).uniq
      end

    end

  end
end
