require 'thor'
require "sftp/sync/runner"

module Sftp
  module Sync
    class CLI < Thor

      desc "pull", "Syncs files from remote SFTP"
      option :filter
      option :output_dir
      option :remove_local, :type => :boolean
      option :gitignore, :type => :boolean, :default => true

      def pull
        runner = Sftp::Sync::Runner.new(options)
        runner.pull
      end


      desc "diff", "Diffs local files from remote SFTP"
      option :filter
      option :output_dir
      option :gitignore, :type => :boolean, :default => true
      option :verbose, :type => :boolean, :default => false
      def diff
        runner = Sftp::Sync::Runner.new(options)
        runner.diff
      end


      desc "list", "Lists files to be synced from remote SFTP"
      option :filter
      option :gitignore, :type => :boolean, :default => true
      def list
        runner = Sftp::Sync::Runner.new(options)
        runner.list
      end

    end
  end
end